﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Xml;
using System.Xml.Linq;
using System.Net;
using System.Windows.Interop;
using System.ServiceModel.Syndication;

namespace TerryLee.SyndicationFeedReader
{
    public partial class Page : UserControl
    {
        public Page()
        {
            InitializeComponent();
        }

        /// <summary>
        /// 显示列表
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void displayButton_Click(object sender, RoutedEventArgs e)
        {
            Uri uri = new Uri(feedAddress.Text);
            WebRequest request = (WebRequest)WebRequest.Create(uri);
            request.BeginGetResponse(new AsyncCallback(responseReady), request);
        }

        void responseReady(IAsyncResult asyncResult)
        {
            WebRequest request = (WebRequest)asyncResult.AsyncState;
            WebResponse response = (WebResponse)request.EndGetResponse(asyncResult);

            XmlReader reader = XmlReader.Create(response.GetResponseStream());
            SyndicationFeed feed = SyndicationFeed.Load(reader);

            PostsList.ItemsSource = feed.Items;
        }

        /// <summary>
        /// 全屏显示
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void fullScreenButton_Click(object sender, RoutedEventArgs e)
        {
            Content contentObject = Application.Current.Host.Content;
            contentObject.IsFullScreen = !contentObject.IsFullScreen;
        }

        /// <summary>
        /// 查看详细信息
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void PostsList_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            SyndicationItem item = PostsList.SelectedItem as SyndicationItem;

            Detail.DataContext = item;
        }
    }
}
